<?php
  // $Id$

	/**
	 * @file
	 * view callbacks for the relay module.
	 */
	 

  /**
   * theme_relay_fullnode function
   * returns html code for displaying specified node.
   * @param string $node
   * @return $htmlCode
   */
   function theme_relay_fullnode($node) {
  // echo variable_get('site_mail');
	$userProfileURL = 'http://'.$_SERVER['HTTP_HOST'].url('user/'.$node->uid);
	$downloadLink = file_create_url($node->field_relay_file[0]['filepath']);
//	echo $downloadLink.'<br/>';
	//$downloadLink = str_ireplace(' ','%20',$downloadLink) ;
//	echo $downloadLink;
	$htmlCode = '';
    $path = drupal_get_path('module', 'relay');
    drupal_add_css($path . '/relayViewStyle.css');
    $duration = '';
	if($node->outputDuration<60) {
		$duration = $node->outputDuration . ' Sec';
	}
	else
	{
		$mins = floor ($node->outputDuration / 60);
		$secs = $node->outputDuration % 60;
		$duration = $mins . '.' . $secs . ' Min';
	}

	if($node->youTubeId!='')    {
        //  it's you tube
        $ytStatus = $node->youTubeStatus;
        $play = 'local';
        if($ytStatus==0)
        {
        	//   if YouTube Status is 0 then it checks YouTube to see if the video is published.  If it is published the status is updated to 1 and the video plays from YouTube.  Otherwise the YouTube status is not updated and the video plays local.  
            $ytuserName = variable_get('relay_utube_username', '');
		    $ytpassWord = variable_get('relay_utube_password', '');
		    $ytsource = variable_get('relay_utube_source', '');
		    $ytdevelKey = variable_get('relay_utube_develKey', '');
		    $ytappId = variable_get('relay_utube_appId', '');
		    $ytclientId = variable_get('relay_utube_ClientId', '');
		    try {
			    $yt = create_anonymous_utube_con();
				$videoEntry = $yt->getVideoEntry($node->youTubeId);
				$yt = createUTubeCon($ytuserName, $ytpassWord, $ytsource, $ytdevelKey, $ytappId, $ytclientId);
	
				//	playlist stufff
				$playListTitle = $node->profile;
				$playlistListFeed = $yt->getPlaylistListFeed('default');
				$foundPlayList = false ;
				foreach ($playlistListFeed as $playlistListEntry) {
					$PlayListName = $playlistListEntry->title->text ;
					if($PlayListName == $playListTitle)	{
						$playlistToAddTo = $playlistListEntry;
						$foundPlayList = true ;
						break ;
					}
				}
				if($foundPlayList == false)
				{
					//	create new play list
					$newPlaylist = $yt->newPlaylistListEntry();
					$newPlaylist->description = $yt->newDescription()->setText('description of my new playlist');
					$newPlaylist->title = $yt->newTitle()->setText($playListTitle);
					// post the new playlist
					$postLocation = 'http://gdata.youtube.com/feeds/api/users/default/playlists';
					try {
					  $yt->insertEntry($newPlaylist, $postLocation);
					  $playlistToAddTo = $newPlaylist;
					  $foundPlayList = true ;
					} catch (Zend_Gdata_App_Exception $e) {
					  echo $e->getMessage();
					  $foundPlayList = false ;
					}
				}
				if($foundPlayList == true)	{
					try{
						$postUrl = $playlistToAddTo->getPlaylistVideoFeedUrl();
						// video entry to be added
						$videoEntryToAdd = $videoEntry ;
						// create a new Zend_Gdata_PlaylistListEntry, passing in the underling DOMElement of the VideoEntry
						$newPlaylistListEntry = $yt->newPlaylistListEntry($videoEntryToAdd->getDOM());
						// post
						  $yt->insertEntry($newPlaylistListEntry, $postUrl);
						} catch (Zend_App_Exception $e) {
						  echo $e->getMessage();
						}
				}

				$ytURL = "http://www.youtube.com/watch?v=".$node->youTubeId;
				//	email to people on config page
				$mailLst = variable_get('relay_utube_email_notify', '');
				$subject = 'Relay Video uploaded to You Tube';
				$body = drupal_wrap_mail('You Tube URL: '.$ytURL.' ');
				$headers =  array('From'=>variable_get('site_mail', 'root@localhost'));
				$result = drupal_mail_send(array(
												'headers' => $headers,
												'to' => $mailLst, 
												'subject' => $subject, 
												'body' => $body
												)
										  );		
				if (!$result) {
					echo 'Error sending e-mail';
				}
				//	video is published
				$node->youTubeStatus = 1;
				node_save($node);
				$play = 'utube';
			}
			catch(Exception $e)
		 	{ 
		 		//	video is not yet published
		 		$play = 'local';
				//	echo '<b>Message: ' .$e->getMessage().'</b>';
		 	}
		 }else if($ytStatus==1)	{
		 	//	If YouTube Status is 1 then play YouTube
		 	$play = 'utube';
		 }
      
            $ytURL = "http://www.youtube.com/watch%3Fv%3D".$node->youTubeId;
            $ytPageURL = "http://www.youtube.com/watch?v=".$node->youTubeId;
            if($play == 'utube') {
	        		$embedcode ='<object width="425" height="344"><param name="allowfullscreen" value="true"></param><param name="movie" value="' . $ytURL .'&hl=en&fs=1"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="' . $ytURL .'&hl=en&fs=1" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="425" height="344"></embed></object>';
				    $htmlCode = '<div id="relay_container">
	<div id="relay_player">'.'<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="/'. $path.'/player.swf" width="425" height="344" allowfullscreen="true" flashvars="file=' . $ytURL .'&image=http://i.ytimg.com/vi/'.$node->youTubeId.'/0.jpg&autostart=false"/></object>'.'</div>
	<div id="relay_desc" >
	<div id="video_author"><b>Author: </b><a href="'.$userProfileURL.'">'.$node->userName.'</a></div>
	<div id="video_date"><b>Date: </b>'.$node->date.'</div>
	<div id="video_res"><b>Resolution: </b>'.$node->outputResolution.'</div>
	<div id="video_dur"><b>Duration: </b>'.$duration.'</div>
	<div id="video_links">
	<table align="left"><tr><td width=10%>Download Link: </td><td>
	<a href="/'. $path.'/forceDownload.php?filePath='.$downloadLink.'">Here</a></td></tr>
	<tr><td>embed: </td><td>
	<textarea rows="6" cols="21">'.$embedcode.'</textarea> 
	</td></tr>
	<tr><td>You Tube URL: </td><td>
	<a href="'.$ytPageURL.'">Here</a></td></tr>
	</table>
	</div>
	</div>
	
	</div>';
			}else if($play == 'local')	{
						$myPlayer = 'http://'.$_SERVER['HTTP_HOST'].'/'.$path.'/player.swf';
                        $embedcode ='<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="'.$myPlayer.'" width="425" height="344" allowfullscreen="true" flashvars="file=' . $downloadLink .'&autostart=false"/></object>';
                        $htmlCode = '<div id="relay_container">
   
  <div id="relay_player">'.'<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="/'. $path.'/player.swf" width="425" height="344" allowfullscreen="true" flashvars="file=' . $downloadLink .'&autostart=false"/></object>'.'</div>
  <div id="relay_desc" >
    <div id="video_author"><b>Author: </b><a href="'.$userProfileURL.'">'.$node->userName.'</a></div>
    <div id="video_date"><b>Date: </b>'.$node->date.'</div>
    <div id="video_res"><b>Resolution: </b>'.$node->outputResolution.'</div>
	<div id="video_dur"><b>Duration: </b>'.$duration.'</div>
    <div id="video_links">
      <form id="form2" name="form2" method="post" action="">
<table align="left"><tr><td width=10%>Download Link: </td><td>
          <a href="/'. $path.'/forceDownload.php?filePath='.$downloadLink.'">Here</a></td></tr>
          <tr><td>embed: </td><td>
          <textarea rows="6" cols="21">'.$embedcode.'</textarea></td></tr>
          </table>
      </form>
    </div>
  </div>
  
</div>';

			}
	
    }
    else {
			$ytURL = "http://www.youtube.com/watch?v=".$node->youTubeId;
            //  Detect file type from file extension(mp3,mp4,youtube,camrec)
            $fileExt = end(explode('.',$downloadLink)); 
            $otherFileType = false;
            switch (strtolower($fileExt))
            {
                case 'mp3':
                		$imageFile = 'http://'.$_SERVER['HTTP_HOST'].'/'.$path.'/mp3.gif';
                		$embedcode ='<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="'.$myPlayer.'" width="425" height="344" flashvars="file=' . $downloadLink .'&autostart=false&image='.$imageFile.'"/></object>';
                        $htmlCode = '<div id="relay_container">
   
  <div id="relay_player">'.'<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="/'. $path.'/player.swf" width="425" height="344" flashvars="file=' . $downloadLink .'&autostart=false&image='.$imageFile.'"/></object>'.'</div>
  <div id="relay_desc" >
    <div id="video_author"><b>Author: </b><a href="'.$userProfileURL.'">'.$node->userName.'</a></div>
    <div id="video_date"><b>Date: </b>'.$node->date.'</div>
    <div id="video_res"><b>Resolution: </b>'.$node->outputResolution.'</div>
	<div id="video_dur"><b>Duration: </b>'.$duration.'</div>
    <div id="video_links">
      <form id="form2" name="form2" method="post" action="">
<table align="left"><tr><td width=10%>Download Link: </td><td>
          <a href="/'. $path.'/forceDownload.php?filePath='.$downloadLink.'">Here</a></td></tr>
          <tr><td>embed: </td><td>
          <textarea rows="6" cols="21">'.$embedcode.'</textarea></td></tr>
          </table>
      </form>
    </div>
  </div>
  
</div>';

                        break;
                case 'mp4':
                		$myPlayer = 'http://'.$_SERVER['HTTP_HOST'].'/'.$path.'/player.swf';
                        $embedcode ='<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="'.$myPlayer.'" width="425" height="344" allowfullscreen="true" flashvars="file=' . $downloadLink .'&autostart=false"/></object>';
                        $htmlCode = '<div id="relay_container">
   
  <div id="relay_player">'.'<object width="425" height="344"><param name="allowfullscreen" value="true"></param><embed id="myplayer" name="myplayer" src="/'. $path.'/player.swf" width="425" height="344" allowfullscreen="true" flashvars="file=' . $downloadLink .'&autostart=false"/></object>'.'</div>
  <div id="relay_desc" >
    <div id="video_author"><b>Author: </b><a href="'.$userProfileURL.'">'.$node->userName.'</a></div>
    <div id="video_date"><b>Date: </b>'.$node->date.'</div>
    <div id="video_res"><b>Resolution: </b>'.$node->outputResolution.'</div>
	<div id="video_dur"><b>Duration: </b>'.$duration.'</div>
    <div id="video_links">
      <form id="form2" name="form2" method="post" action="">
<table align="left"><tr><td width=10%>Download Link: </td><td>
          <a href="/'. $path.'/forceDownload.php?filePath='.$downloadLink.'">Here</a></td></tr>
          <tr><td>embed: </td><td>
          <textarea rows="6" cols="21">'.$embedcode.'</textarea></td></tr>
          </table>
      </form>
    </div>
  </div>
  
</div>';

                        break;
                case 'camrec':
                		$imageErrorFile = 'http://'.$_SERVER['HTTP_HOST'].'/'.$path.'/camrec.gif';
                        $htmlCode = '<div id="relay_container">
   
  <div id="relay_player">'.'<img style="border-bottom-color: black; border-bottom-style: solid; border-bottom-width: 40px;border-top-color: black; border-top-style: solid; border-top-width: 40px" width=425 height=264 alt="camrec file" src="'.$imageErrorFile.'"/></div>
  <div id="relay_desc" >
    <div id="video_author"><b>Author: </b><a href="'.$userProfileURL.'">'.$node->userName.'</a></div>
    <div id="video_date"><b>Date: </b>'.$node->date.'</div>
    <div id="video_res"><b>Resolution: </b>'.$node->outputResolution.'</div>
	<div id="video_dur"><b>Duration: </b>'.$duration.'</div>
    <div id="video_links">
      <form id="form2" name="form2" method="post" action="">
<table align="left"><tr><td width=10%>Download Link: </td><td>
          <a href="/'. $path.'/forceDownload.php?filePath='.$downloadLink.'">Here</a></td></tr>
          </table>
      </form>
    </div>
  </div>
  
</div>';

                        break;
                default:
                        $htmlCode = 'Unidentified file type';
                        $otherFileType = true;
           
		}
	}
  return $htmlCode;
}
?>