<?php
// $Id$

	/**
	 * @file
	 * You Tube callbacks for the relay module.
	 */
	 
/**
   * createUTubeCon function
   * returns authenticated you tube connection object.
   * @param string $param_user
   * @param string $param_pass
   * @param string $param_source
   * @param string $param_develKey
   * @param string $param_appId
   * @param string $param_clientId
   * @return $yt
   */
function createUTubeCon($param_user,$param_pass,$param_source,$param_develKey,$param_appId,$param_clientId)                    
{     
    require_once 'Zend/Loader.php'; // the Zend dir must be in your include_path
	Zend_Loader::loadClass('Zend_Gdata_YouTube');
	Zend_Loader::loadClass('Zend_Gdata_ClientLogin'); 
	try
	{
		$authenticationURL='https://www.google.com/youtube/accounts/ClientLogin';
		/////   You Tube Credentials
		$httpClient = Zend_Gdata_ClientLogin::getHttpClient(
	 	$username = $param_user,
	  	$password = $param_pass,
	    $service = 'youtube',
	    $client = null,
	    $source = $param_source, // a short string identifying your application
	    $loginToken = null,
	    $loginCaptcha = null,
	    $authenticationURL);
		$developerKey = $param_develKey;
		$applicationId = $param_appId;
		$clientId = $param_clientId;
		$yt = new Zend_Gdata_YouTube($httpClient, $applicationId, $clientId, $developerKey);
	}
	catch(Exception $e)
	 { 
		 echo '<b>Message: ' .$e->getMessage().'</b>';
		 $errMsg = $e->getMessage();
		 watchdog('relay', 'Failed to Create You Tube Connection.'.$errMsg , null, WATCHDOG_ERROR, NULL);
	 }
	return($yt);
}

/**
   * create_anonymous_utube_con function
   * returns anonymous you tube connection object.
   * @return $yt
   */
function create_anonymous_utube_con()                    
{     
		
    require_once 'Zend/Loader.php'; // the Zend dir must be in your include_path
	Zend_Loader::loadClass('Zend_Gdata_YouTube');
	Zend_Loader::loadClass('Zend_Gdata_ClientLogin'); 
	
	$param_user = 'USERNAME';
	$param_pass = 'PASSWORD';
	$param_source = 'SOURCE';
	$param_develKey = 'DEVELKEY';
	$param_appId = 'APPID';
	$param_clientId = 'CLIENTID';

	try
	{
		$authenticationURL='https://www.google.com/youtube/accounts/ClientLogin';
		/////   You Tube Credentials
		$httpClient = Zend_Gdata_ClientLogin::getHttpClient(
		 	$username = $param_user,
		  	$password = $param_pass,
		    $service = 'youtube',
		    $client = null,
		    $source = $param_source, // a short string identifying your application
		    $loginToken = null,
		    $loginCaptcha = null,
		    $authenticationURL);
		$developerKey = $param_develKey;
		$applicationId = $param_appId;
		$clientId = $param_clientId;
		$yt = new Zend_Gdata_YouTube($httpClient, $applicationId, $clientId, $developerKey);
	}
	catch(Exception $e)
	 { 
		 echo '<b>Message: ' .$e->getMessage().'</b>';
		 $errMsg = $e->getMessage();
		 watchdog('relay', 'Failed to Create You Tube Connection.'.$errMsg , null, WATCHDOG_ERROR, NULL);
	 }
	return($yt);
}

/**
   * upload_video function
   * returns videoId of the uploaded video.
   * @param string $yt
   * @param string $filePath
   * @param string $media_title
   * @param string $media_description
   * @param string $tagArray
   * @param string $playListTitle
   * @return $videoId
   */
function upload_video($yt,$filePath,$media_title,$media_description,$tagArray,$playListTitle) {
	// create a new Zend_Gdata_YouTube_VideoEntry object
	$myVideoEntry = new Zend_Gdata_YouTube_VideoEntry();
	$filesource = $yt->newMediaFileSource($filePath);
	$filesource->setContentType('video/quicktime');
	// set slug header
	
	$filesource->setSlug(end(explode('/',$filePath)));
	// add the filesource to the video entry
	$myVideoEntry->setMediaSource($filesource);
	//	the limit for title is 60 characters and for the tags it is 250
	//	http://www.reelseo.com/imovie-08-video-seo/
	if (strlen($media_title)>59)	{
		$media_title = substr($media_title,0,58);
	}
	$myVideoEntry->setVideoTitle($media_title);
	$myVideoEntry->setVideoDescription($media_description);
	$myVideoEntry->setVideoCategory('Education'); // Note that category must be a valid YouTube category !
	
	// set keywords, please note that this must be a comma separated string
	// and that each keyword cannot contain whitespace
	
	$videoTags = $tagArray;
	if (strlen($media_title)>249)	{
		$videoTags = substr($videoTags,0,248);
	}
	$myVideoEntry->setVideoTags($videoTags);
	
	// optionally set some developer tags (see Searching by Developer Tags for more details)
	$myVideoEntry->setVideoDeveloperTags(array('mydevelopertag', 'anotherdevelopertag'));
	
	// optionally set the video's location
	$yt->registerPackage('Zend_Gdata_Geo');
	$yt->registerPackage('Zend_Gdata_Geo_Extension');
	$where = $yt->newGeoRssWhere();
	$position = $yt->newGmlPos('37.0 -122.0');
	$where->point = $yt->newGmlPoint($position);
	$myVideoEntry->setWhere($where);
	// upload URI for the currently authenticated user
	$uploadUrl = 'http://uploads.gdata.youtube.com/feeds/users/default/uploads';
	
	// try to upload the video, catching a Zend_Gdata_App_HttpException if available
	// or just a regular Zend_Gdata_App_Exception

	try {
		$newEntry = $yt->insertEntry($myVideoEntry, $uploadUrl, 'Zend_Gdata_YouTube_VideoEntry');
		watchdog('relay', "uploaded to You Tube", null, WATCHDOG_NOTICE, NULL);
		$videoId = $newEntry->getVideoId();
	}
	catch(Exception $e)
	 { 
		 echo '<b>Message: ' .$e->getMessage().'</b>';
		 $errMsg = $e->getMessage();
		 watchdog('relay', 'Failed to upload to You Tube.'.$errMsg , null, WATCHDOG_ERROR, NULL);
		 //	utube failed.
		 //	so play local
	 }
	return $videoId;
}

/**
   * array2csv function
   * returns coma seperated elements from array.
   * @param string $array
   * @return $csv
   */
function array2csv($array) {
    $csv = "";
    for( $i = 0; $i < count($array); $i++ ) {
          $csv .=  str_replace('"', '""', $array[$i]);
        if( $i < count($array) - 1 ) $csv .= ",";
    }
    return $csv;
}
?>